<?php
function HikashopBuildRoute( &$query )
{
	$segments = array();
	if(!defined('DS'))
		define('DS', DIRECTORY_SEPARATOR);
	if(function_exists('hikashop_config') || include_once(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_hikashop'.DS.'helpers'.DS.'helper.php')){
		$config =& hikashop_config();
		if($config->get('activate_sef',1)){
			$categorySef=$config->get('category_sef_name','category');
			$productSef=$config->get('product_sef_name','product');
			$checkoutSef=$config->get('checkout_sef_name','checkout');
			$cartSef=$config->get('cart_sef_name','cart');
			$wishlistSef=$config->get('wishlist_sef_name','wishlist');
			if(empty($categorySef)){
				$categorySef='';
			}
			if(empty($productSef)){
				$productSef='';
			}

			if(isset($query['ctrl']) && isset($query['task'])){
				if($query['ctrl']=='category' && $query['task']=='listing'){
					$segments[] = $categorySef;
					unset( $query['ctrl'] );
					unset( $query['task'] );
				}
				else if($query['ctrl']=='product' && $query['task']=='show'){
					$segments[] = $productSef;
					unset( $query['ctrl'] );
					unset( $query['task'] );
				}
			}
			/* code not needed anymore..causes issues with Joomla adding extra parts to the URLs it generates
			else if(isset($query['view']) && isset($query['layout'])){
				if($query['view']=='category' && $query['layout']=='listing'){
					$segments[] = $categorySef;
					unset( $query['layout'] );
					unset( $query['view'] );
				}
				else if($query['view']=='product' && $query['layout']=='show'){
					$segments[] = $productSef;
					unset( $query['layout'] );
					unset( $query['view'] );
				}
			}
			*/
			//remove checkout controller from URL when not needed
			if( ( isset($query['ctrl']) && $query['ctrl']=='checkout' || isset($query['view']) && $query['view']=='checkout' ) && !empty($query['Itemid']) && ( !isset($query['task']) && !isset($query['layout']) || (isset($query['task']) && $query['task']=='step' ) || (isset($query['layout']) && $query['layout']=='step' )) ) {
				if(empty($checkoutSef)){
					$menuClass = hikashop_get('class.menus');
					$menu = $menuClass->get($query['Itemid']);
					if(!empty($menu) && !empty($menu->link) && $menu->link =='index.php?option=com_hikashop&view=checkout&layout=step'){
						if(isset($query['ctrl'])) unset($query['ctrl']);
						if(isset($query['view'])) unset($query['view']);
					}
				}else{
					if(isset($query['ctrl'])) unset($query['ctrl']);
					if(isset($query['view'])) unset($query['view']);
					if(!empty($checkoutSef)) $segments[] = $checkoutSef;
				}
			}
			//manage the cart and wishlist urls
			if( ( isset($query['ctrl']) && $query['ctrl']=='cart' || isset($query['view']) && $query['view']=='cart' ) && !empty($query['Itemid']) && ( !isset($query['task']) && !isset($query['layout']) || (isset($query['task']) && $query['task']=='showcart' ) || (isset($query['layout']) && $query['layout']=='showcart' )) ) {
				$type = 'cart';
				if(empty($cartSef) || empty($wishlistSef)){
					$menuClass = hikashop_get('class.menus');
					$menu = $menuClass->get($query['Itemid']);
					if(!empty($menu) && !empty($menu->link) && $menu->link =='index.php?option=com_hikashop&view=cart&layout=showcart'){
						if(isset($query['ctrl'])) unset($query['ctrl']);
						if(isset($query['view'])) unset($query['view']);
					}
				}else{
					if(isset($query['ctrl'])) unset($query['ctrl']);
					if(isset($query['view'])) unset($query['view']);
					if(isset($query['cart_type']) && $query['cart_type'] == 'cart' && !empty($cartSef))
						$segments[] = $cartSef;
					if(isset($query['cart_type']) && $query['cart_type'] == 'wishlist' && !empty($wishlistSef))
						$segments[] = $wishlistSef;
				}
				if(isset($query['task'])){
					$segments[] = $query['task'];
					unset($query['task']);
				}
				if(isset($query['layout'])){
					$segments[] = $query['layout'];
					unset($query['layout']);
				}
				if(isset($query['cart_type'])) unset($query['cart_type']);
			}
		}
		$pathway_sef_name = $config->get('pathway_sef_name','category_pathway');
		if(isset($query[$pathway_sef_name])&& (empty($query[$pathway_sef_name])) || $config->get('simplified_breadcrumbs',1)){
			unset( $query[$pathway_sef_name] );
		}
		if(isset($query[$pathway_sef_name])){
			$category_pathway = $config->get('category_pathway','category_pathway');
			if($category_pathway!='category_pathway' && !empty($category_pathway)){
				$query[$category_pathway]=$query[$pathway_sef_name];
				unset( $query[$pathway_sef_name] );
			}
		}
		$related_sef_name = $config->get('related_sef_name','related_product');
		if(isset($query[$related_sef_name])&& $config->get('simplified_breadcrumbs',1)){
			unset( $query[$related_sef_name] );
		}
	}

	if (isset($query['ctrl'])) {
		$segments[] = $query['ctrl'];
		unset( $query['ctrl'] );
		if (isset($query['task'])) {
			$segments[] = $query['task'];
			unset( $query['task'] );
		}
	}elseif(isset($query['view'])){
		unset( $query['view'] );
		if(isset($query['layout'])){
			unset( $query['layout'] );
		}
	}

	if(isset($query['product_id'])){
		$query['cid'] = $query['product_id'];
		unset($query['product_id']);
	}
	if(isset($query['cart_id'])){
		$query['cid'] = $query['cart_id'];
		unset($query['cart_id']);
	}

	if(isset($type) && $type == 'cart' && isset($query['cid'])){
		if($config->get('sef_cart_remove_id',0) && isset($query['name'])){
			//add a letter at the beginning of the alias to avoid issues when the alias of a product starts with a number
			$int_at_the_beginning = (int)$query['name'];
			if($int_at_the_beginning){
				$query['name'] = $config->get('alias_prefix','p').$query['name'];
			}
			$segments[] = $query['name'];
		}elseif(isset($query['name'])){
			if(is_numeric($query['name'])){
				$query['name']=$query['name'].'-';
			}
			$segments[] = $query['cid'].':'.$query['name'];
		}else{
			$segments[] = $query['cid'];
		}
		unset($query['cid']);
		unset($query['name']);
	}

	if(isset($query['cid']) && isset($query['name']) && (!isset($type) || $type != 'cart')){
		if($config->get('sef_remove_id',0) && !empty($query['name'])){
			//add a letter at the beginning of the alias to avoid issues when the alias of a product starts with a number
			$int_at_the_beginning = (int)$query['name'];
			if($int_at_the_beginning){
				$query['name'] = $config->get('alias_prefix','p').$query['name'];
			}
			$segments[] = $query['name'];
		}else{
			if(is_numeric($query['name'])){
				$query['name']=$query['name'].'-';
			}
			$segments[] = $query['cid'].':'.$query['name'];
		}
		unset($query['cid']);
		unset($query['name']);
	}

	if(!empty($query)){
		foreach($query as $name => $value){
			if(!in_array($name,array('option','Itemid','start','format','limitstart','lang'))){
//				if($name=='name'){
//					$segments[] = $value;
//				}else{
					if(is_array($value)) $value = implode('-',$value);
					$segments[] = $name.':'.$value;
//				}
				unset($query[$name]);
			}
		}
	}

	return $segments;
}
function HikashopParseRoute( $segments )
{

	$vars = array();
	$check=false;
	if(!empty($segments)){
		if(!defined('DS'))
			define('DS', DIRECTORY_SEPARATOR);
		if(function_exists('hikashop_config') || include_once(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_hikashop'.DS.'helpers'.DS.'helper.php')){
			$config =& hikashop_config();
			if($config->get('activate_sef',1)){
				$categorySef=$config->get('category_sef_name','category');
				$productSef=$config->get('product_sef_name','product');
				$cartSef=$config->get('cart_sef_name','cart');
				$wishlistSef=$config->get('wishlist_sef_name','wishlist');
				$checkoutSef=$config->get('checkout_sef_name','checkout');
				$skip=false;
				if(isset($segments[0])){
					$file = HIKASHOP_CONTROLLER.$segments[0].'.php';
					if(file_exists($file) && isset($segments[1])){
						if(!($segments[0]=='product'&&$segments[1]=='show' || $segments[0]=='category'&&$segments[1]=='listing' || $segments[0]=='checkout'&&$segments[1]=='notice') || $segments[0]=='cart'&&$segments[1]=='showcart'){
							$controller = hikashop_get('controller.'.$segments[0],array(),true);
							if($controller->isIn($segments[1],array('display','modify_views','add','modify','delete'))){
								$skip = true;
							}
						}
					}
				}

				if(!$skip){

					if(count($segments)==1){
						if(empty($categorySef)){
							$vars['ctrl']='category';
							$vars['task']='listing';
						}
						elseif(empty($productSef)){
							$vars['ctrl']='product';
							$vars['task']='show';
						}
						elseif(empty($cartSef) || empty($wishlistSef)){
							$vars['ctrl']='cart';
							$vars['task']='showcart';
						}
					}

					$i = 0;

					foreach($segments as $k => $name){
						if(strpos($name,':')){
							if(empty($productSef) && !$check){
								$vars['ctrl']='product';
								$vars['task']='show';
							}
							list($arg,$val) = explode(':',$name,2);
							if($arg=='task'&&$val=='step'){
								$vars['ctrl']='checkout';
							}
							if(is_numeric($arg) && !is_numeric($val)){
								$vars['cid'] = $arg;
								$vars['name'] = $val;
							}elseif(is_numeric($arg)){
								$vars['Itemid'] = $arg;
							}elseif(str_replace(':','-',$name)==$productSef){
								$vars['ctrl']='product';
								$vars['task']='show';
							}else if(str_replace(':','-',$name)==$categorySef){
								$vars['ctrl']='category';
								$vars['task']='listing';
								$check=true;
							}else if(str_replace(':','-',$name)==$cartSef || str_replace(':','-',$name)==$wishlistSef){
								$vars['ctrl']='cart';
								$vars['task']='showcart';
								$check=true;
							}else{
								if(hikashop_retrieve_url_id($vars,$name)) continue;
								$vars[$arg] = $val;
							}
						}else if($name==$productSef){
							$vars['ctrl']='product';
							$vars['task']='show';
						}else if($name==$categorySef){
							$vars['ctrl']='category';
							$vars['task']='listing';
							$check=true;
						}else if($name==$cartSef || $name==$wishlistSef || $name == 'showcart'){
							$vars['ctrl']='cart';
							$vars['task']='showcart';
							$check=true;
						}else if($name==$checkoutSef && ( $name!= 'checkout' || !isset($segments[$k+1]) || $segments[$k+1] != 'notice' )){
							$vars['ctrl']='checkout';
							$vars['task']='step';
							$check=true;
						}else{
							if(hikashop_retrieve_url_id($vars,$name)) continue;
							$i++;
							if($i == 1 && !isset($vars['ctrl'])) $vars['ctrl'] = $name;
							elseif($i == 2 && !isset($vars['ctrl'])) $vars['task'] = $name;
							if(is_numeric($name))
								$vars['cid'] = $name;
							$check=true;
						}
					}

					return $vars;
				}
				$i = 0;
				foreach($segments as $name){
					if(strpos($name,':')){
						list($arg,$val) = explode(':',$name,2);
						if(is_numeric($arg) && !is_numeric($val)){
							$vars['cid'] = $arg;
							$vars['name'] = $val;
						}elseif(is_numeric($arg)){
							if(hikashop_retrieve_url_id($vars,$name)) continue;
							$vars['Itemid'] = $arg;
						}else{
							if(hikashop_retrieve_url_id($vars,$name)) continue;
							$vars[$arg] = $val;
						}
					}else{
						if(hikashop_retrieve_url_id($vars,$name)) continue;
						$i++;
						if($i == 1) $vars['ctrl'] = $name;
						elseif($i == 2) $vars['task'] = $name;
						if(is_numeric($name))
							$vars['cid'] = $name;
					}
				}
				$category_pathway = $config->get('category_pathway','category_pathway');
				if($category_pathway!='category_pathway' && isset($vars[$category_pathway])){
					$vars['category_pathway']=$vars[$category_pathway];
				}
			}else{
				foreach($segments as $name){
					hikashop_retrieve_url_id($vars,$name);
				}
			}

		}
	}
	return $vars;
}

function hikashop_retrieve_url_id(&$vars,$name){
	$config =& hikashop_config();
	$db = JFactory::getDBO();

	if(!isset($vars['ctrl']) || !isset($vars['task']))
		return false;

	if($vars['ctrl']=='category' || ($vars['ctrl']=='product' && $vars['task']=='listing')){
		//query for category
		$type = 'category';
	}elseif($vars['ctrl']=='product' && $vars['task']=='show'){
		//query for product
		$type = 'product';
	}elseif(($vars['ctrl']=='cart' || $vars['ctrl']=='wishlist') && ($vars['task']=='showcart' || $vars['task']=='show')){
		//query for cart
		$type = 'cart';
	}else{
		return false;
	}

	if(($config->get('sef_remove_id',0) && !in_array($type,array('category','product'))) || ($config->get('sef_cart_remove_id',0) && $type != 'cart'))
		return false;

	//we suppose that the alias is already filled for the element and so we first run a simple query on the alias in order to make sure we get accurate results and speed up the processing
	$class = hikashop_get('helper.translation');
	if($class->isMulti()){
		$trans_table = 'jf_content';
		if($class->falang){
			$trans_table = 'falang_content';
		}
		$db->setQuery('SELECT reference_id FROM '.hikashop_table($trans_table,false).' WHERE reference_table='.$db->Quote('hikashop_'.$type).' AND reference_field='.$db->Quote($type.'_alias').' AND value = '.$db->Quote(str_replace(':','-',$name)));
		$retrieved_id = $db->loadResult();
		if($retrieved_id){
			$vars['cid'] = $retrieved_id;
			$vars['name'] = $name;
			return true;
		}
	}

	$db->setQuery('SELECT '.$type.'_id FROM '.hikashop_table($type).' WHERE '.$type.'_alias = '.$db->Quote(str_replace(':','-',$name)));
	$retrieved_id = $db->loadResult();
	if($retrieved_id){
		$vars['cid'] = $retrieved_id;
		$vars['name'] = $name;
		return true;
	}


	//if the auto fill mode is deactivated or if we couldn't find any alias matching, we run the regex query for dynamic alias generation
	$name_regex = '^ *p?'.str_replace(array('-',':'),'.+',$name).' *$';
	$class = hikashop_get('helper.translation');
	if($class->isMulti()){
		$trans_table = 'jf_content';
		if($class->falang){
			$trans_table = 'falang_content';
		}
		$db->setQuery('SELECT reference_id FROM '.hikashop_table($trans_table,false).' WHERE reference_table='.$db->Quote('hikashop_'.$type).' AND ((reference_field='.$db->Quote($type.'_alias').' AND (value = '.$db->Quote(str_replace(':','-',$name)).' OR value REGEXP '.$db->Quote($name_regex).')) OR (reference_field='.$db->Quote($type.'_name').' AND value REGEXP '.$db->Quote($name_regex).'))');
		$retrieved_id = $db->loadResult();
		if($retrieved_id){
			$vars['cid'] = $retrieved_id;
			$vars['name'] = $name;
			return true;
		}
	}

	$db->setQuery('SELECT * FROM '.hikashop_table($type).' WHERE '.$type.'_alias REGEXP '.$db->Quote($name_regex).' OR '.$type.'_name REGEXP '.$db->Quote($name_regex));
	$retrieved = $db->loadObject();

	if($retrieved){
		$type_id = $type.'_id';
		$vars['cid'] = $retrieved->$type_id;
		$vars['name'] = $name;
		//force the alias to be set if the alias auto fill option is activated
		if($config->get('alias_auto_fill',1)){
			$type_alias = $type.'_alias';
			if(empty($retrieved->$type_alias)){
				$class = hikashop_get('class.'.$type);
				$class->addAlias($retrieved);

				//add a letter at the beginning of the alias to avoid issues when the alias of a product starts with a number
				if($config->get('sef_remove_id',0)){
					$int_at_the_beginning = (int)$retrieved->alias;
					if($int_at_the_beginning){
						$retrieved->alias = $config->get('alias_prefix','p').$retrieved->alias;
					}
				}

				$element = new stdClass();
				$element->$type_id = $retrieved->$type_id;
				$element->$type_alias = $retrieved->alias;

				$class->save($element);
			}
		}
		return true;
	}
}